Package org.apache.storm.topology.base

## Class BaseTickTupleAwareRichBolt

- java.lang.Object
- - org.apache.storm.topology.base.BaseComponent
  - - org.apache.storm.topology.base.BaseRichBolt
    - - org.apache.storm.topology.base.BaseTickTupleAwareRichBolt

- All Implemented Interfaces:
    `Serializable`, `IBolt`, `IComponent`, `IRichBolt`
  Direct Known Subclasses:
    `AbstractJdbcBolt`, `AbstractRedisBolt`, `JmsBolt`, `KafkaBolt`

      public abstract class BaseTickTupleAwareRichBolt
      extends BaseRichBolt

  This class is based on BaseRichBolt, but is aware of tick tuple.
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BaseTickTupleAwareRichBolt()` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `execute​(Tuple tuple)` | Process a single tuple of input.
    `protected void` | `onTickTuple​(Tuple tuple)` | Process a single tick tuple of input.
    `protected abstract void` | `process​(Tuple tuple)` | Process a single non-tick tuple of input.

    - ### Methods inherited from class org.apache.storm.topology.base.BaseRichBolt

      `cleanup`

    - ### Methods inherited from class org.apache.storm.topology.base.BaseComponent

      `getComponentConfiguration`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.storm.task.IBolt

      `prepare`

    - ### Methods inherited from interface org.apache.storm.topology.IComponent

      `declareOutputFields, getComponentConfiguration`

- - ### Constructor Detail

    - #### BaseTickTupleAwareRichBolt

          public BaseTickTupleAwareRichBolt()

  - ### Method Detail

    - #### execute

          public void execute​(Tuple tuple)

      Process a single tuple of input. The Tuple object contains metadata on it about which component/stream/task it came from. The values of the Tuple can be accessed using Tuple#getValue. The IBolt does not have to process the Tuple immediately. It is perfectly fine to hang onto a tuple and process it later (for instance, to do an aggregation or join).

      Tuples should be emitted using the OutputCollector provided through the prepare method. It is required that all input tuples are acked or failed at some point using the OutputCollector. Otherwise, Storm will be unable to determine when tuples coming off the spouts have been completed.

      For the common case of acking an input tuple at the end of the execute method, see IBasicBolt which automates this.

      Parameters:
        `tuple` - the tuple to process.

    - #### onTickTuple

          protected void onTickTuple​(Tuple tuple)

      Process a single tick tuple of input. Tick tuple doesn't need to be acked. It provides default "DO NOTHING" implementation for convenient. Override this method if needed.

      More details on `IBolt.execute(Tuple)`.

      Parameters:
        `tuple` - The input tuple to be processed.

    - #### process

          protected abstract void process​(Tuple tuple)

      Process a single non-tick tuple of input. Implementation needs to handle ack manually. More details on `IBolt.execute(Tuple)`.
      Parameters:
        `tuple` - The input tuple to be processed.